#include "joy.h"

enum DeviceKind { keyboard, mouse, joystick } CurrentDevice;
BOOL					g_FFAvailable;
LPDIRECTINPUTDEVICE2	g_lpdidKeyboard,g_lpdidJoy;
LPDIRECTINPUT			lpdi;
DIDEVICEINSTANCE		diDeviceInstanceKeyb, diDeviceInstanceJoy;
DWORD					ChangeButton;
LPDIRECTINPUTEFFECT		g_lpTriggerEffect;
BOOL					g_TriggerOK;

DLL_EXPORT int STD IniciarDInput (long Tipo_Dispositivo)
{
	HRESULT					hr;
	HINSTANCE				hinst;
	
	switch (Tipo_Dispositivo)
	{
	case 0:
		CurrentDevice=keyboard;
		break;
	case 1:
		CurrentDevice=joystick;
		break;
	default:
		CurrentDevice=keyboard;
		break;
	}

	//  Intentamos crear un objeto Direct Input

	hinst=GetModuleHandle(NULL);
	hr=DirectInputCreate (hinst,DIRECTINPUT_VERSION,&lpdi,NULL);

	//	Si no se puede crear el objeto Direct Input devolvemos false

	if (hr!=DI_OK){
		return false;
	}
	
	//	Hemos conseguido crear el objeto Direct Input y continuamos
	//   continuamos con su inicializacin

	lpdi->EnumDevices(DIDEVTYPE_JOYSTICK,Reasignacion,lpdi,DIEDFL_ATTACHEDONLY);
	g_lpdidKeyboard=CreateDevice2 (lpdi,( GUID * )&GUID_SysKeyboard);

	diDeviceInstanceKeyb.dwSize = sizeof( DIDEVICEINSTANCE );
	diDeviceInstanceJoy.dwSize = sizeof( DIDEVICEINSTANCE );
    g_lpdidKeyboard->GetDeviceInfo( &diDeviceInstanceKeyb );
	hr = g_lpdidKeyboard->SetDataFormat( &c_dfDIKeyboard );

	if ( g_lpdidJoy == NULL ) 
	{
		if (CurrentDevice==joystick) CurrentDevice=keyboard;
	}
	else if ( g_lpdidJoy != NULL )
	{
		g_lpdidJoy->GetDeviceInfo( &diDeviceInstanceJoy );
		if ( GET_DIDEVICE_TYPE( diDeviceInstanceJoy.dwDevType )== DIDEVTYPE_JOYSTICK)
		{
            hr = g_lpdidJoy->SetDataFormat( &c_dfDIJoystick );
		}
	}
/*
    switch ( GET_DIDEVICE_TYPE( diDeviceInstanceJoy.dwDevType ) )
    {
		case DIDEVTYPE_KEYBOARD:
            hr = g_lpdidKeyboard->SetDataFormat( &c_dfDIKeyboard );
            CurrentDevice = keyboard;
            break;

        case DIDEVTYPE_MOUSE:
            hr = g_lpdid2->SetDataFormat( &c_dfDIMouse );
            CurrentDevice = mouse;
            break;

        case DIDEVTYPE_JOYSTICK:
            hr = g_lpdidJoy->SetDataFormat( &c_dfDIJoystick );
            CurrentDevice = joystick;
            break;
    }
*/
	// Fijar el nivel cooperativo. 
/*
    DWORD cl, cl1;
    if ( CurrentDevice == keyboard ) 
    {
		cl = DISCL_NONEXCLUSIVE;
	}
    else 
	{
		cl = DISCL_EXCLUSIVE;
	}

// Fije nivel de primer plano para la versin comercial, pero use el nivel de segundo plano
// para la depuracin para no perder el dispositivo cuando pase a una ventana del 
// depurador. Fjese en que el ratn no puede tener nivel de segundo plano exclusivo.

    cl1 = DISCL_FOREGROUND;
#ifdef _DEBUG
    cl1 = DISCL_BACKGROUND;
    if ( CurrentDevice == mouse ) cl = DISCL_NONEXCLUSIVE;
#endif

    if ( FAILED( g_lpdid2->SetCooperativeLevel( handle,
                                cl | cl1 ) ) )
    {
        OutputDebugString( "Fallo al fijar el nivel cooperativo del dispositivo de juego.\n" );
        g_lpdid2 = NULL;
    }
*/
    // Configurar el buffer de datos.

    DIPROPDWORD dipdw =
    {
        // La cabecera, la cual inicializamos	(DIPROHEADER)
        {
            sizeof( DIPROPDWORD ),      // diph.dwSize
            sizeof( DIPROPHEADER ),     // diph.dwHeaderSize
            0,                          // diph.dwObj
            DIPH_DEVICE,                // diph.dwHow
        },
        // Nmero de elementos en el buffer de datos	(DWORD)
        BUFFERSIZE,              // dwData		
    };

	switch (CurrentDevice)
	{
	case keyboard:
		g_lpdidKeyboard->SetProperty( DIPROP_BUFFERSIZE, &dipdw.diph );
		break;
	case joystick:
		g_lpdidJoy->SetProperty( DIPROP_BUFFERSIZE, &dipdw.diph );
		break;
	}

	if ( CurrentDevice == joystick )
    { 
        IniJoystick();  
    }
	SetAcquireState( TRUE );
	return true;
}

int STD Reasignacion (LPCDIDEVICEINSTANCE pdinst, LPVOID pvRef)
{	
	LPDIRECTINPUT pdi = LPDIRECTINPUT (pvRef); 

	g_lpdidJoy=CreateDevice2 (pdi,( GUID * ) &pdinst->guidInstance);
	return DIENUM_CONTINUE; 
}

LPDIRECTINPUTDEVICE2 CreateDevice2( LPDIRECTINPUT lpdi, GUID* pguid)
{
    HRESULT hr, hr2;
  
    LPDIRECTINPUTDEVICE  lpdid1;  // Temporal.
    LPDIRECTINPUTDEVICE2 lpdid2;  // Para guardar la interfaz.

    hr = lpdi->CreateDevice( *pguid, &lpdid1, NULL );
 
    if ( SUCCEEDED( hr ) )
    { 
        hr2 = lpdid1->QueryInterface( IID_IDirectInputDevice2, 
                                      ( void ** )&lpdid2 ); 
        lpdid1->Release();
    } 
    else
    {
        OutputDebugString( 
			"No se pudo crear el dispositivo IDirectInputDevice" );
        return NULL;
    } 
    if ( FAILED( hr2 ) )
    {
        OutputDebugString( 
			"No se pudo crear el dispositivo IDirectInputDevice2" );
        return NULL;
    } 
    return lpdid2;
}  // CreateDevice2

BOOL IniJoystick( void )
{
    // Fijar ranto. 
    // Nota: rango, zona muerta, y saturacin se fijan para todo el
    // dispositivo. Ello podra provocar efectos no deseados sobre
    // los mandos deslizantes, ruedecillas, etc.

    DIPROPRANGE diprg; 
 
    diprg.diph.dwSize       = sizeof( diprg ); 
    diprg.diph.dwHeaderSize = sizeof( diprg.diph ); 
    diprg.diph.dwObj        = 0; 
    diprg.diph.dwHow        = DIPH_DEVICE; 
    diprg.lMin              = JOYMIN; 
    diprg.lMax              = JOYMAX; 
 
    if ( FAILED( g_lpdidJoy->SetProperty( DIPROP_RANGE, &diprg.diph ) ) )
        return FALSE; 

    // Fijar zona muerta.
    DIPROPDWORD dipdw;

    dipdw.diph.dwSize       = sizeof( dipdw ); 
    dipdw.diph.dwHeaderSize = sizeof( dipdw.diph ); 
    dipdw.diph.dwObj        = 0;
    dipdw.diph.dwHow        = DIPH_DEVICE;
    dipdw.dwData            = JOYDEAD;

    if ( FAILED( g_lpdidJoy->SetProperty( DIPROP_DEADZONE, &dipdw.diph ) ) )
        return FALSE;

    // Fijar saturacin.
    dipdw.dwData            = JOYSAT;
    if ( FAILED( g_lpdidJoy->SetProperty( DIPROP_SATURATION, &dipdw.diph ) ) )
        return FALSE;

    // Averiguar si hay disponibles efectos resistivos.
    DIDEVCAPS didc;
    didc.dwSize = sizeof( DIDEVCAPS );
    if ( FAILED( g_lpdidJoy->GetCapabilities( &didc ) ) ) 
        return FALSE;
    g_FFAvailable = ( didc.dwFlags & DIDC_FORCEFEEDBACK );

    // Si es un joystick con efectos resistivos, desactivar el auto centrado para que
    // se interponga con nuestros efectos.
    if ( g_FFAvailable )
    {
        DIPROPDWORD DIPropAutoCenter;
        DIPropAutoCenter.diph.dwSize = sizeof( DIPropAutoCenter );
        DIPropAutoCenter.diph.dwHeaderSize = sizeof( DIPROPHEADER );
        DIPropAutoCenter.diph.dwObj = 0;
        DIPropAutoCenter.diph.dwHow = DIPH_DEVICE;
        DIPropAutoCenter.dwData = 0;

        g_lpdidJoy->SetProperty( DIPROP_AUTOCENTER, 
                               &DIPropAutoCenter.diph );
    } 
    return TRUE;
}   // InitJoystick

BOOL SetAcquireState( BOOL acq )
{
    HRESULT hr;

    if ( !acq )  // Desadquirir.
    {
		switch (CurrentDevice)
		{
		case keyboard:
			hr = g_lpdidKeyboard->Unacquire();
			break;
		case joystick:
			hr = g_lpdidJoy->Unacquire();
			break;
		}
    }
    else       // Adquirir.
    {
// Podra llevar algo de tiempo con efectos resistivos.
		switch (CurrentDevice)
		{
		case keyboard:
			hr = g_lpdidKeyboard->Acquire();
			break;
		case joystick:
			hr = g_lpdidJoy->Acquire();
			break;
		}

/*        if ( SUCCEEDED( hr ) ) 
        {
            // Inicializar efectos; ignorar los fallos y slo
            // solicitar efectos resistivos.
            if ( g_FFAvailable )      // Fijada por vez primera al inicializar el dispositivo.
            {
                g_FFAvailable = InitFFEffects();
            }
        }
*/
    }
    /* Mientras estamos aqu, podramos recuperar el tiempo de doble clic.
       Si el usuario est regresando del Panel de control aqu se obtendra cualquier
       configuracin nueva. */

//    DoubleClickTime = GetDoubleClickTime();

    return ( SUCCEEDED( hr ) );
} // SetAcquireState


/****************************************************************
**  Devuelve el estado de las teclas de control del Navegador  **
**   cuando si utilizamos el Direct Input                      **
*****************************************************************/
DLL_EXPORT Respuesta STD DirectInputPollDevice( void )
{
    DIJOYSTATE			dijs;
    char				keys[256]; 
    static	DWORD		LastClickTime;
	long				dato=10;
	Respuesta			Pulsiones;			
    HRESULT				hr;
    DIDEVICEOBJECTDATA	rgdod[BUFFERSIZE];
    DWORD				dwItems; 

	Pulsiones.Abajo=Pulsiones.Arriba=Pulsiones.Izquierda=Pulsiones.Derecha=false;
	Pulsiones.Switch =false;

 	ChangeButton=BOTON_ELEGIDO;

	switch (CurrentDevice)
	{
	case keyboard:
		if ( !g_lpdidKeyboard ) return Pulsiones;
		break;
	case joystick:
		if ( !g_lpdidJoy ) return Pulsiones;
		break;
	}

getBufferedData:

    dwItems = BUFFERSIZE;
	switch (CurrentDevice)
	{
	case keyboard:
	    g_lpdidKeyboard->Poll();  // Puede no ser necesario, pero no perjudica.

		hr = g_lpdidKeyboard->GetDeviceData( sizeof( DIDEVICEOBJECTDATA ), 
						rgdod,         // Dnde colocar los datos?
						&dwItems,      // Cuntos elementos?
						0 );           // Banderas.
		break;
	case joystick:
	    g_lpdidJoy->Poll();  // Puede no ser necesario, pero no perjudica.

		hr = g_lpdidJoy->GetDeviceData( sizeof( DIDEVICEOBJECTDATA ), 
						rgdod,         // Dnde colocar los datos?
						&dwItems,      // Cuntos elementos?
						0 );           // Banderas.
		break;
	}

    // Si se interrumpi el flujo de datos, readquirir el dispositivo e intentarlo de nuevo.
    if ( hr == DIERR_INPUTLOST )
    {
        if ( SetAcquireState( TRUE ) )
            goto getBufferedData;
    }

    // No podemos adquirir el dispositivo. Abandonar.
    if ( hr == DIERR_NOTACQUIRED )
    {
        OutputDebugString( "Dispositivo no adquirido!" );
        return Pulsiones;
    }

    // Obtuvimos entrada desde un buffer; actuar.
/*    if ( SUCCEEDED( hr ) ) 
    { 
        // dwItems ahora contiene el nmero de elementos ledos (podra ser 0).
        // Pasamos por la secuencia de sucesos. Si el suceso est asociado con
        // un botn de disparo definido por el usuario, y si el botn "est pulsado"
        // disparamos.

        for ( DWORD d = 0; d < dwItems; d++ )
        {
            if ( rgdod[d].dwOfs == BOTON_ELEGIDO ) // Si es el botn de disparo.
            {
				Pulsiones.Switch =true;
				for (i=0;i<=BUFFERSIZE;i++){rgdod[i].dwOfs =NULL;}
            }  // If botn de disparo.

            if ( CurrentDevice == mouse )
            {
                if ( rgdod[d].dwOfs == DIMOFS_X )
//                    UpdateCursorPosition( rgdod[d].dwData, 0 );
                else if ( rgdod[d].dwOfs == DIMOFS_Y )
//                    UpdateCursorPosition( 0, rgdod[d].dwData );
            } // Ratn.

        }  // Concluido el bucle de sucesos.
	}
*/    
getImmediateData:
    switch ( CurrentDevice )
    {
        case keyboard:
            hr = g_lpdidKeyboard->GetDeviceState( sizeof( keys ), keys );  
            break;
        case joystick:
            hr = g_lpdidJoy->GetDeviceState( sizeof( DIJOYSTATE ), &dijs ); 
            break;
    }

    // Se interrupi el flujo de datos. Readquirir el dispositivo e intentarlo de nuevo.
    if ( hr == DIERR_INPUTLOST )
    {
        if ( SetAcquireState( TRUE ) )
            goto getImmediateData;
    }
    if ( hr == DIERR_NOTACQUIRED )
    {
        OutputDebugString( "Dispositivo no adquirido!" );
        return Pulsiones;
    }

    // Tenemos datos inmediatos, actuar sobre ellos.  
    if ( SUCCEEDED( hr ) )
    {
        switch ( CurrentDevice )
        {
            case keyboard:
                if ( BUTTONDOWN( keys[DIK_LEFT] ) )
					Pulsiones.Izquierda=true;
				if ( BUTTONDOWN( keys[DIK_RIGHT] ) )
					Pulsiones.Derecha=true;
				if ( BUTTONDOWN( keys[DIK_UP] ) )
					Pulsiones.Arriba=true;
                if ( BUTTONDOWN( keys[DIK_DOWN] ) )
					Pulsiones.Abajo=true;
//				if (BUTTONDOWN( keys[57])){
//					Pulsiones.Switch=true;
//					Sleep (500);
//				}
                break;

            case mouse:
                break;

            case joystick:
                if ( dijs.lX < 0 ) 
					Pulsiones.Izquierda=true;
                if ( dijs.lX > 0 ) 
					Pulsiones.Derecha=true;
                if ( dijs.lY < 0 ) 
					Pulsiones.Arriba=true;
                if ( dijs.lY > 0 ) 
					Pulsiones.Abajo=true;
				if ( dijs.rgbButtons[0]!=0 || dijs.rgbButtons[1]!=0) 
					Pulsiones.Switch=true;
                break;
        } // switch
        return Pulsiones;  // Tuvimos datos.
    }
    else              // FAILED( hr )
        return Pulsiones;
}  // PollDevice()


/****************************************************************
**  Devuelve el estado de las teclas de control del Navegador  **
**   cuando no utilizamos el Direct Input                      **
*****************************************************************/
DLL_EXPORT Respuesta STD NonDirectInputPollDevice( void )
{
	Respuesta			Pulsiones;	
	BYTE				KeysState[256];

	//	Inicializamos el estado de las pulsaciones a falso
	Pulsiones.Abajo=Pulsiones.Arriba=Pulsiones.Izquierda=Pulsiones.Derecha=false;
	Pulsiones.Switch =false;

	GetKeyboardState((LPBYTE)&KeysState);

	//  Comparamos el estado de KeysState[tecla] con el bit
	//  ms significativo que es el que me dice si esta pulsada
	//  o no
	if (KeysState[VK_UP] & 128) Pulsiones.Arriba=true;
	if (KeysState[VK_DOWN] & 128) Pulsiones.Abajo=true;
	if (KeysState[VK_LEFT] & 128) Pulsiones.Izquierda=true;
	if (KeysState[VK_RIGHT] & 128) Pulsiones.Derecha=true;
	if (KeysState[VK_SPACE] & 128) Pulsiones.Switch=true;
	return Pulsiones;
}

DLL_EXPORT void STD CerrarDInput (void)
{
    SetAcquireState( FALSE );

    g_lpdidKeyboard->Release();
    g_lpdidKeyboard=NULL;

    if ( g_lpdidJoy != NULL ) 
    {
        g_lpdidJoy->Release();
        g_lpdidJoy = NULL;
    }

    if ( lpdi != NULL )
    { 
        lpdi->Release();
        lpdi = NULL;
    }
}

