#include <stdio.h>


/**
 **********************************************************************
* Estructura de datos utilizada en el algoritmo
 de bsqueda de un punto interno a un punto; define un vrtice
  *********************************************************************/
    /* polygon vertex definition */
typedef struct vertex_struct {
  double x,y;                   /* coordinate values */
  struct vertex_struct  *next;  /* circular singly linked list from poly */
  } vtx, *vtx_ptr;

/**
 **********************************************************************
 * Estructura de datos utilizada en el algoritmo
 de bsqueda de un punto interno a un punto; define un polgono 
 *********************************************************************/
    /* polygon definition */
typedef struct polygon_struct {
  char name[100];
  vtx_ptr last;         /* pointer to end of circular vertex list */
  } polygon, *polygon_ptr;

    /* return next vertex in polygon list of vertices */
#define polygon_get_vertex(poly, vertex)                    \
    ((vertex == NULL) ? poly->last->next : vertex->next)

    /* create and insert new polygon vertex */
#define polygon_new_vertex(poly, xx, yy, new_vertex) {  \
    new_vertex  = (vtx_ptr) malloc (sizeof(vtx));           \
    new_vertex->x = xx;                                     \
    new_vertex->y = yy;                                     \
    if (poly->last != NULL) {                               \
      new_vertex->next = poly->last->next;                  \
      poly->last->next = new_vertex;                        \
      }                                                     \
    else {                                                  \
      new_vertex->next = new_vertex;                        \
      }                                                     \
    poly->last = new_vertex;                                \
    }

    /* create new polygon */
#define polygon_create(poly)                                \
    poly = (polygon_ptr) malloc(sizeof (polygon));          \
    poly->last = NULL;

        /* quadrant id's, incremental angles, accumulated angle values */
typedef short quadrant_type;

        /* result value from point in polygon test */
typedef enum pt_poly_relation {DENTRO, FUERA} pt_poly_relation;

pt_poly_relation point_in_poly(polygon_ptr poly, double x, double y);
int point_on_edge(vtx_ptr vertex1, vtx_ptr vertex2, double x, double y);